// Generated by CoffeeScript 1.6.3
(function() {
  var __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  require(["Theme", "Map", "gamenode", "base"], function(Theme, Map) {
    var client, gameId, initalizeAuthorTools, mapPainter, session, showGame, showPlayers, theme;
    client = new GameNodeClient(Skeleton);
    this.gameNodeClient = client;
    session = null;
    gameId = /[?&]gameId=([0-9a-f]+)/.exec(window.location.search);
    if (gameId !== null) {
      gameId = gameId[1];
    } else {
      document.location = "/";
    }
    theme = null;
    mapPainter = null;
    $(document).ready(function() {
      var loginUrl;
      loginUrl = "login.html?next=" + document.location.pathname + document.location.search;
      return session = resumeSessionOrRedirect(client, WARS_CLIENT_SETTINGS.gameServer, loginUrl, function() {
        client.stub.subscribeGame(gameId);
        populateNavigation(session);
        return client.stub.profile(function(response) {
          theme = new Theme(response.profile.settings.gameTheme);
          if (gameId !== null) {
            return theme.load(function() {
              mapPainter = new Map(undefined, 1.0, theme);
              mapPainter.canvas = $("#mapCanvas")[0];
              return client.stub.gameData(gameId, function(response) {
                if (response.success) {
                  if (response.game.state !== "pregame") {
                    document.location = "game.html?gameId=" + gameId;
                  }
                  initializeChat(client, gameId);
                  return showGame(response.game, response.author);
                } else {
                  return alert("Error loading game!" + response.reason);
                }
              });
            });
          }
        });
      });
    });
    showGame = function(game, author) {
      $("#gameName").text(game.name);
      if (author) {
        initalizeAuthorTools();
      } else {
        $("#authorTools").hide();
      }
      return mapPainter.doPreload(function() {
        var height, mapSize, width;
        showPlayers(game.players, author);
        mapPainter.tiles = game.tiles;
        mapSize = mapPainter.getMapDimensions();
        width = mapSize.e(1);
        height = mapSize.e(2);
        mapPainter.canvas.width = width;
        mapPainter.canvas.height = height;
        return mapPainter.refresh();
      });
    };
    showPlayers = function(players, authorMode) {
      var player, playerList, _fn, _i, _len;
      players.sort(function(a, b) {
        return a.playerNumber - b.playerNumber;
      });
      playerList = $("#players");
      _fn = function(player) {
        var item, joinButton, leaveButton, leaveButtonContainer, name, nameContainer, number, option, p, teamContainer, teamSelect, _j, _len1;
        item = $("<tr></tr>");
        number = $("<td></td>");
        nameContainer = $("<td></td>");
        name = $("<span></span>");
        item.addClass("playerItem");
        item.attr("playerNumber", player.playerNumber);
        number.text(player.playerNumber);
        number.css("background-color", theme.getPlayerColorString(player.playerNumber));
        number.addClass("playerNumber");
        if (player.playerName != null) {
          name.text(player.playerName);
        }
        name.addClass("playerName");
        joinButton = $("<span></span>");
        joinButton.addClass("joinButton");
        joinButton.text("Click to join!");
        leaveButtonContainer = $("<td></td>");
        leaveButton = $("<span></span>");
        leaveButton.addClass("leaveButton");
        leaveButton.text("X");
        teamContainer = $("<td></td>");
        teamSelect = $("<select></select>");
        teamSelect.addClass("teamSelect");
        teamSelect.prop("disabled", !player.isMe && !authorMode);
        for (_j = 0, _len1 = players.length; _j < _len1; _j++) {
          p = players[_j];
          option = $("<option></option>");
          option.attr("value", p.playerNumber);
          option.text("Team " + p.playerNumber);
          option.prop("selected", p.playerNumber === player.teamNumber);
          teamSelect.append(option);
        }
        nameContainer.append(name);
        nameContainer.append(joinButton);
        leaveButtonContainer.append(leaveButton);
        teamContainer.append(teamSelect);
        item.append(number);
        item.append(nameContainer);
        item.append(teamContainer);
        item.append(leaveButtonContainer);
        if (player.userId === null) {
          joinButton.show();
          leaveButton.hide();
        } else {
          joinButton.hide();
          leaveButton.toggle(player.isMe || authorMode);
        }
        joinButton.click(function() {
          return client.stub.joinGame(gameId, player.playerNumber, function(response) {
            if (!response.success) {
              return alert("Error joining game!" + response.reason);
            }
          });
        });
        leaveButton.click(function() {
          return client.stub.leaveGame(gameId, player.playerNumber, function(response) {
            if (!response.success) {
              return alert("Error leaving game!" + response.reason);
            }
          });
        });
        teamSelect.change(function() {
          var teamNumber;
          teamNumber = parseInt($(this).val());
          return client.stub.setTeam(gameId, player.playerNumber, teamNumber, function(response) {
            if (!response.success) {
              return alert("Error setting team!" + response.reason);
            }
          });
        });
        return playerList.append(item);
      };
      for (_i = 0, _len = players.length; _i < _len; _i++) {
        player = players[_i];
        _fn(player);
      }
      client.skeleton.playerJoined = function(gameId, playerNumber, playerName, isMe) {
        var joinButton, leaveButton, nameLabel, teamSelect;
        nameLabel = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .playerName");
        joinButton = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .joinButton");
        leaveButton = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .leaveButton");
        teamSelect = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .teamSelect");
        nameLabel.text(playerName);
        joinButton.hide();
        leaveButton.toggle(isMe || authorMode);
        return teamSelect.prop("disabled", !isMe && !authorMode);
      };
      client.skeleton.playerLeft = function(gameId, playerNumber) {
        var joinButton, leaveButton, nameLabel, teamSelect;
        nameLabel = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .playerName");
        joinButton = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .joinButton");
        leaveButton = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .leaveButton");
        teamSelect = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .teamSelect");
        joinButton.removeClass("joined");
        nameLabel.text("");
        joinButton.show();
        leaveButton.hide();
        return teamSelect.prop("disabled", !authorMode);
      };
      client.skeleton.gameStarted = function(gameId) {
        return document.location = "game.html?gameId=" + gameId;
      };
      return client.skeleton.playerTeamChanged = function(gameId, playerNumber, teamNumber, playerName, isMe) {
        var teamSelect;
        teamSelect = $(".playerItem[playerNumber=\"" + playerNumber + "\"] .teamSelect");
        return teamSelect.val(teamNumber);
      };
    };
    return initalizeAuthorTools = function() {
      var populateBannedUnitSelections, setBannedUnitsToServer;
      $("#startGame").click(function(e) {
        e.preventDefault();
        return client.stub.startGame(gameId, function(response) {
          if (!response.success) {
            return alert("Error starting game! " + response.reason);
          }
        });
      });
      $("#deleteGame").click(function(e) {
        e.preventDefault();
        return client.stub.deleteGame(gameId, function(response) {
          if (response.success) {
            return document.location = "/login.html";
          } else {
            return alert("Error deleting game! " + response.reason);
          }
        });
      });
      $("#inviteForm").submit(function(e) {
        var username;
        e.preventDefault();
        username = $("#username").val();
        if (username.length > 0) {
          return client.stub.addInvite(gameId, username, function(response) {
            if (!response.success) {
              return alert("Error inviting user! " + response.reason);
            }
          });
        }
      });
      client.stub.botNames(function(names) {
        var item, name, _i, _len, _results;
        if ((names == null) || names.length === 0) {
          return $("#inviteForm").hide();
        } else {
          _results = [];
          for (_i = 0, _len = names.length; _i < _len; _i++) {
            name = names[_i];
            item = $("<option></option>");
            item.attr("value", name);
            item.text(name);
            _results.push($("#username").append(item));
          }
          return _results;
        }
      });
      client.stub.gameRules(gameId, function(rules) {
        return populateBannedUnitSelections(rules);
      });
      populateBannedUnitSelections = function(rules) {
        return forEachProperty(rules.units, function(unit) {
          var option, _ref;
          option = $("<option id='" + unit.id + "'>" + unit.name + "</option>");
          if (_ref = unit.id, __indexOf.call(rules.bannedUnits, _ref) >= 0) {
            return $("#bannedUnits").append(option);
          } else {
            return $("#notBannedUnits").append(option);
          }
        });
      };
      $("#banUnit").click(function(e) {
        var banned, selected, _i, _len, _ref;
        e.preventDefault();
        _ref = $("#notBannedUnits option:selected");
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          selected = _ref[_i];
          $("#notBannedUnits").find(selected).remove;
          $("#bannedUnits").append(selected);
        }
        banned = $.map($("#bannedUnits option"), function(option) {
          return option.id;
        });
        return setBannedUnitsToServer(banned);
      });
      $("#removeFromBannedUnits").click(function(e) {
        var banned, selected, _i, _len, _ref;
        e.preventDefault();
        _ref = $("#bannedUnits option:selected");
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          selected = _ref[_i];
          $("#bannedUnits").find(selected).remove;
          $("#notBannedUnits").append(selected);
        }
        banned = $.map($("#bannedUnits option"), function(option) {
          return option.id;
        });
        return setBannedUnitsToServer(banned);
      });
      return setBannedUnitsToServer = function(bannedUnits) {
        var bannedUnitsInts, u;
        bannedUnitsInts = (function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = bannedUnits.length; _i < _len; _i++) {
            u = bannedUnits[_i];
            _results.push(parseInt(u));
          }
          return _results;
        })();
        return client.stub.setBannedUnits(gameId, bannedUnitsInts, function(response) {
          if (response.success) {

          } else {
            return alert("Cannot add units to ban list! " + response.reason);
          }
        });
      };
    };
  });

}).call(this);
